#!/usr/bin/python2.7
# -*- coding: utf-8 -*-
#

#  Copyright (C) 2014-2015  Rafael Senties Martinelli <rsm@imap.cc>
#
#  This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License 3 as published by
#   the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software Foundation,
#   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA.



from gi.repository import Gtk
import os


# local imports
from Paths import *
from Texts import *


def GTK_default_font_color():
	settings=Gtk.Settings.get_default()
	
	colors=settings.get_property("gtk-color-scheme")
	colors=colors.split("\n")
	
	
	for color in colors:
		if 'text' in color:
			text_color=color.split(':')[1].strip()
			return text_color
			break


def GTK_info(PARENT,text1,text2):

		dialog=Gtk.MessageDialog(	PARENT,
									Gtk.DialogFlags.MODAL,
									Gtk.MessageType.INFO,
									Gtk.ButtonsType.CLOSE,
									text1)
									
		dialog.set_default_response(Gtk.ResponseType.NONE)
		dialog.set_icon_from_file(ICON_LOGO_SMALL)

		if text2 != None:
			dialog.format_secondary_text(text2)
		
		response=dialog.run()
		dialog.destroy()


def GTK_folder_chooser(PARENT):

	window_choose_folder=Gtk.FileChooserDialog("Video List Player",
												PARENT,
												Gtk.FileChooserAction.SELECT_FOLDER,
												(Gtk.STOCK_CANCEL, 
													Gtk.ResponseType.CANCEL,
													Gtk.STOCK_OPEN, 
													Gtk.ResponseType.OK))

	window_choose_folder.set_icon_from_file(ICON_LOGO_SMALL)
	
	window_choose_folder.set_current_folder(HOME_PATH)
	
	response=window_choose_folder.run()
	if response == Gtk.ResponseType.OK:
		folder_path=window_choose_folder.get_filename()
		window_choose_folder.destroy()
		
		if folder_path and os.path.exists(folder_path):
			default_folder_chooser_path=os.path.dirname(folder_path)
		
		return folder_path
	else:
		window_choose_folder.destroy()
		return False
		
		
		
def GTK_file_chooser(PARENT,MODE):

	window_choose_file=Gtk.FileChooserDialog(	"Video List Player",
												PARENT,
												Gtk.FileChooserAction.OPEN,
												(Gtk.STOCK_CANCEL, 
													Gtk.ResponseType.CANCEL,Gtk.STOCK_OPEN, 
													Gtk.ResponseType.OK))
													
	window_choose_file.set_default_response(Gtk.ResponseType.NONE)
	window_choose_file.set_icon_from_file(ICON_LOGO_SMALL)
	
	window_choose_file.set_transient_for(PARENT)

	if MODE=="picture":
		filter=Gtk.FileFilter()
		filter.set_name("Picture")
		filter.add_pattern("*.jpeg")
		filter.add_pattern("*.jpg")
		filter.add_pattern("*.png")
		window_choose_file.add_filter(filter)	

	window_choose_file.set_current_folder(HOME_PATH)
	
	response=window_choose_file.run()
	if response == Gtk.ResponseType.OK:
		file_path=window_choose_file.get_filename()
		window_choose_file.destroy()
		
		if file_path and os.path.exists(file_path):
			default_file_chooser_path=(os.path.dirname(file_path))
		
		return file_path
	else:
		window_choose_file.destroy()		
		return False
		
def GTK_dialog_question(PARENT,text1,text2):

	dialog=Gtk.MessageDialog(	PARENT,
								Gtk.DialogFlags.MODAL,
								Gtk.MessageType.QUESTION,
								Gtk.ButtonsType.YES_NO,
								text1)
	
	
	dialog.set_icon_from_file(ICON_LOGO_SMALL)
	
	if text2 != None:
		dialog.format_secondary_text(text2)
	
	response=dialog.run()
	if response == Gtk.ResponseType.YES:
		dialog.hide()
		return True
		
	elif response == Gtk.ResponseType.NO:
		dialog.hide()
		return False
