#!/usr/bin/python2.7
# -*- coding: utf-8 -*-
#

#  Copyright (C) 2014-2015  Rafael Senties Martinelli <rsm@imap.cc>
#
#  This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License 3 as published by
#   the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software Foundation,
#   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA.


from gi.repository import Gtk, GObject, Gdk
import sys, threading, time


# local imports
from Paths import *
from PyGobject_vlc import *
from CustomOs import *; CustomOs=CustomOs()
from SeriesAndVideos import *
from Texts import *
from CustomGtk import *
from CustomParser import *; CustomParser=CustomParser()


def VLC_scan(self):
	
	state=self.vlc.player.get_state()
	
	while True:
		# if the player was stopped
		stopped_position=self.vlc.stopped_position
		if stopped_position > 0:
			for serie in self.list_series_class:
				if serie==self.current_media[0]:
					serie.set_video_position(self.current_media[1],stopped_position)
					break
			
			
		# If the current video got to the end..
		if round(self.vlc.player.get_position(),3) >= 0.999:
			
			EPISODE_change_state(self)
			EPISODE_update(self)
			
			Gdk.threads_enter()
			GUI_update_episodes_menu(self,True)
			Gdk.threads_leave()
			
			
			if self.checkbutton_keep_playing.get_active():
				if self.current_media[1]:
					vlc_play_video( self.vlc.player, 
									self.current_media[1].get_path(),
									self.window_player, 
									True, 
									self.current_media[1].get_position())
				else:
					self.vlc.player.stop()
					
					Gdk.threads_enter()
					self.window_player.hide()
					Gdk.threads_leave()
					Gdk.threads_enter()
					GTK_info(self.window_root,TEXT_END_OF_SERIE,None)
					Gdk.threads_leave()
			else:
				self.vlc.player.stop()
				Gdk.threads_enter()
				self.window_player.hide()
				Gdk.threads_leave()

		time.sleep(0.5)	


def GUI_update_episodes_menu(self,update_liststore):
		
	if self.selected_row >= 0:
				
		text_serie=self.liststore_series[self.selected_row][1]

		# find the serie
		for serie in self.list_series_class:
			if serie.get_name()==text_serie:

				"""
					update the series area
				"""

				# set the stats and the name
				if self.checkbutton_random.get_active():
					(played,total,percent)=serie.get_r_played_stats()
				else:
					(played,total,percent)=serie.get_o_played_stats()

					
				progress_text=str(played)+"/"+str(total)
				
				self.label_current_serie.set_label(text_serie)
				self.progressbar.set_fraction(percent)
				
				self.progressbar.set_text(progress_text)
				self.progressbar.set_show_text(True)
				
				# set the checkboxes
				self.checkbutton_keep_playing.set_active(serie.get_keep_playing())
				self.checkbutton_random.set_active(serie.get_random())
				
				# set the big image    									this could be improved
				childrens=self.eventbox_selected_serie.get_children()
				for children in childrens:
					self.eventbox_selected_serie.remove(children)
				
				image=serie.get_big_image()
				self.eventbox_selected_serie.add(image)
				image.show()
				
				
				
				"""
					update the episodes area
				"""
				if update_liststore:
					self.liststore_episodes.clear()
					self.treeview_name_column.set_spacing(0)

					if os.path.exists(serie.get_path()):
						
						# inizialize the list
						videos_list=[]
						for video in serie.get_videos():
							videos_list.append(None)
										
						# sort it by id
						for video in serie.get_videos():
							try:
								videos_list[video.get_id()-1]=video
							except Exception,e:
								print (e)
								
						
						for video in videos_list:
							if video:
								
								# get the color of the font
								if video.get_display():
									color=self.default_font_color
								else:
									color=self.hiden_font_color
								
								# add the video to the list store
								if video.get_display() or self.display_hiden_videos:
									self.liststore_episodes.append([video.get_id(),
																	video.get_name(),
																	video.get_state(),
																	video.get_play(),
																	video.get_o_played(),
																	video.get_r_played(),
																	" ",
																	color,
																	])
							else:
								print "Error loading the liststore_episodes. The serie '"+serie.get_name()+"' has an empty video."

				break





def GUI_hide_episodes_menu(self):
	
	(rx,ry)=self.window_root.get_size()
	bx=self.box_episodes.get_allocation().width
	
	if self.box_episodes.get_visible():
		self.box_episodes.hide()
		self.window_root.resize(rx-bx-15,ry) # 15 is the border with
		self.box_main.set_child_packing(self.box_series,True, True, 0, Gtk.PackType.START)
		CustomParser.write_value(CONFIGURATION_FILE,'vlist-player','fullmode','false')
	else:
		self.box_main.set_child_packing(self.box_series, False, False, 0, Gtk.PackType.START)
		self.box_episodes.show_all()
		CustomParser.write_value(CONFIGURATION_FILE,'vlist-player','fullmode','true')
		
		
def GUI_on_toggle(cell, path, model, column, self, *ignore):
	# path is the row number

	if path is not None:
		
		# update the liststore
		it = model.get_iter(path)
		state=not model[it][column]
		model[it][column] = state
		
		# change the list of the class	
		serie=self.list_series_class[self.selected_row]
		episode_name=self.liststore_episodes[path][1]
		serie.change_checkbox_state(episode_name,column,state)
		
		GUI_update_episodes_menu(self,False)
		
def GUI_checkboxes(widget, column, state, self):
	
	(model, rownumbers)=self.selection_episodes.get_selected_rows()
	
	if not rownumbers==[]:
	
		serie=self.list_series_class[self.selected_row]
		
		episode_names=[]
		for rownumber in rownumbers:
			rownumber=int(str(rownumber))
			
			# change the state of the liststore
			self.liststore_episodes[rownumber][column]=state
			
			episode_names.append(self.liststore_episodes[rownumber][1])
			
		serie.change_checkbox_state(episode_names,column,state)		
		
		GUI_update_episodes_menu(self,True)


def EPISODE_open_dir(widget, self, video_name):
	
	selected_serie=self.liststore_series[self.selected_row][1]
	
	for serie in self.list_series_class:
		if serie.get_name()==selected_serie:

			path=serie.get_path_from_video_name(video_name)

			if os.path.exists(path):
				CustomOs.open_directory(path)
			else:
				None
			
			
			break

	
	
def EPISODE_change_state(self):
	# write the new value to the instance video
	for serie in self.list_series_class:
		if serie==self.current_media[0]:
			serie.mark_episode(self.current_media[1],self.current_media[2],True)
			break

def EPISODE_update(self):
	
	selected_serie_name=self.liststore_series[self.selected_row][1]
	
	for serie in self.list_series_class:
		if serie.get_name()==selected_serie_name:
			
			self.current_media[0]=serie
			
			if self.checkbutton_random.get_active():
				self.current_media[1]=serie.get_r_episode()
			else:
				self.current_media[1]=serie.get_o_episode()	
			
			self.current_media[2]=self.checkbutton_random.get_active()


def SERIE_load_from_path(self,path,data_path,recursive,random,keep_playing):
	new_serie=Serie(path,data_path,recursive,random,keep_playing)
	
	# it seems that it is not necessary to put Gdk.threads_.. 
	self.list_series_class.append(new_serie)
	self.liststore_series.append([new_serie.get_image(), new_serie.get_name()])
	
	# select the row once a serie has been added
	i=0
	for row in self.liststore_series:
		if self.liststore_series[i][1]==new_serie.get_name():
			
			Gdk.threads_enter()
			self.treeview_series.set_cursor(i)
			Gdk.threads_leave()
			
			self.selected_row=i
			
			Gdk.threads_enter()
			GUI_update_episodes_menu(self,True)
			Gdk.threads_leave()
			break
	
		i+=1

def SERIE_open(widget, self):
	
	selected_serie=self.liststore_series[self.selected_row][1]
	
	for serie in self.list_series_class:
		if serie.get_name()==selected_serie:
			path=serie.get_path()
			CustomOs.open_directory(path)
			break


def SERIE_find_videos(widget, self, video_names):

	if len(video_names)==1: # if the user only selected one video to find..
		path=GTK_file_chooser(self.window_root,False)
		
		# find the selected serie
		if path:
			serie_name=self.liststore_series[self.selected_row][1]
			for serie in self.list_series_class:
				if serie.get_name()==serie_name:
					
					# add the video
					found_videos=serie.find_video(video_names[0], path)
					
					if found_videos:
						GTK_info(self.window_root,TEXT_X_OTHER_VIDEOS_HAVE_BEEN_FOUND.format(found_videos),None)
					
					break
					
	elif len(video_names)>1:
		path=GTK_folder_chooser(self.window_root)
		
		if path:
			serie_name=self.liststore_series[self.selected_row][1]
			for serie in self.list_series_class:
				if serie.get_name()==serie_name:
					found_videos=serie.find_videos(path)
					
					if found_videos:
						GTK_info(self.window_root,TEXT_X_VIDEOS_HAVE_BEEN_FOUND.format(found_videos),None)
					
					break
		
	
	GUI_update_episodes_menu(self,True)
		
	
	
def SERIE_add_picture(widget, self):
	"""
		Add a picture to a serie
	"""
	file=GTK_file_chooser(self.window_root,"picture")
	if file:
		serie_name=self.liststore_series[self.selected_row][1]
		for serie in self.list_series_class:
			if serie.get_name()==serie_name:
				# add it to the class
				serie.set_image(file)
				
				# add it to the liststore
				self.liststore_series[self.selected_row][0]=serie.get_image()
				
				GUI_update_episodes_menu(self,False)
				
				break
				

def SERIE_find(widget, self):
	
	path=GTK_folder_chooser(self.window_root)
	
	if path:
		serie_name=self.liststore_series[self.selected_row][1]
		for serie in self.list_series_class:
			if serie.get_name()==serie_name:
				serie.find_serie(path)
				GUI_update_episodes_menu(self,True)
				self.liststore_series[self.selected_row][0]=serie.get_image()
				break
	
	

				
def SERIE_reset(widget, self):
	
	selected_serie=self.liststore_series[self.selected_row][1]
	
	if GTK_dialog_question(self.window_root,TEXT_RESET_SERIE.format(selected_serie),None):
	
		for serie in self.list_series_class:
			if serie.get_name()==selected_serie:
				serie.reset_data()
				GUI_update_episodes_menu(self,True)
				break
	
					
				
def SERIE_rename(widget, self):
	"""
		change the name of a serie
	"""
	serie_name=self.liststore_series[self.selected_row][1]
	
	self.label_old_name.set_text(serie_name)
	self.entry_rename.set_text(serie_name)
	
	self.window_rename.show()


def SERIE_delete(widget, self):
	selected_serie=self.liststore_series[self.selected_row][1]
	
	if GTK_dialog_question(self.window_root,TEXT_DELETE_SERIE.format(selected_serie),None):

		# delete the serie from the class list
		for serie in self.list_series_class:
			if serie.get_name()==selected_serie:
				self.list_series_class.remove(serie)
				break
		
		# delete the serie of the liststore
		self.liststore_series.remove(self.liststore_series.get_iter(self.selected_row))
		
		# delete the data of the serie
		if os.path.exists(SERIE_PATH.format(selected_serie)):
			os.remove(SERIE_PATH.format(selected_serie))
			
def SERIE_ignore_episode(widget, self):

	(model, rownumbers)=self.selection_episodes.get_selected_rows()
	
	if not rownumbers==[]:
	
		selected_serie=self.liststore_series[self.selected_row][1]
		for serie in self.list_series_class:
			if serie.get_name()==selected_serie:
				for rownumber in rownumbers:
					rownumber=int(str(rownumber))
					serie.ignore_video(self.liststore_episodes[rownumber][1])
					
				break
					

		GUI_update_episodes_menu(self,True)

def SERIE_dont_ignore_episode(widget, self):


	(model, rownumbers)=self.selection_episodes.get_selected_rows()
	
	if not rownumbers==[]:
	
		selected_serie=self.liststore_series[self.selected_row][1]
		for serie in self.list_series_class:
			if serie.get_name()==selected_serie:
				for rownumber in rownumbers:
					rownumber=int(str(rownumber))
					serie.dont_ignore_video(self.liststore_episodes[rownumber][1])
					
				break
					

		GUI_update_episodes_menu(self,True)


class GUI(object):
	
	def __init__(self, *p):
	
	
		"""
			load items from glade
		"""
		self.builder=Gtk.Builder()
		self.builder.add_from_file(GLADE_FILE)
		self.builder.connect_signals(self)

		# window_root
		self.window_root=self.builder.get_object('window_root')
		self.scrolledwindow_series=self.builder.get_object('scrolledwindow_series')
		self.label_current_serie=self.builder.get_object('label_current_serie')
		self.progressbar=self.builder.get_object('progressbar')
		self.button_root_play_and_stop=self.builder.get_object('button_root_play_and_stop')
		self.scrolledwindow_episodes=self.builder.get_object('scrolledwindow_episodes')
		self.box_episodes=self.builder.get_object('box_episodes')
		self.box_series=self.builder.get_object('box_series')
		self.box_main=self.builder.get_object('box_main')
		self.button_move_down=self.builder.get_object('button_move_down')
		self.button_move_up=self.builder.get_object('button_move_up')
		self.box_serie_data=self.builder.get_object('box_serie_data')
		self.box_series_menu=self.builder.get_object('box_series_menu')
		self.box_main=self.builder.get_object('box_main')
		self.togglebutton_hidden_videos=self.builder.get_object('togglebutton_hidden_videos')
		self.checkbutton_random=self.builder.get_object('checkbutton_random')
		self.checkbutton_keep_playing=self.builder.get_object('checkbutton_keep_playing')
		

		# window_rename
		self.window_rename=self.builder.get_object('window_rename')
		self.entry_rename=self.builder.get_object('entry_rename')
		self.label_old_name=self.builder.get_object('label_old_name')
		
		# other windows
		self.window_player=self.builder.get_object('window_player')
		self.window_about=self.builder.get_object('window_about')
		self.window_controlls=self.builder.get_object('window_controlls')
		self.window_files=self.builder.get_object('window_files')
		self.window_preferences=self.builder.get_object('window_preferences')
		self.window_finding_files=self.builder.get_object('window_finding_files')
		
		
		""" 
			liststore_series
		"""
		self.treeview_series = Gtk.TreeView()
		self.liststore_series = Gtk.ListStore(Pixbuf,str)
		self.treeview_series.set_model(self.liststore_series)
		self.treeview_series.connect('button-press-event' , self.treeview_series_press_event)
		
		self.selection_series=self.treeview_series.get_selection()
		self.selection_series.connect('changed', self.treeview_series_selection_changed)
		
		self.scrolledwindow_series.add(self.treeview_series)
					
		column=Gtk.TreeViewColumn("", Gtk.CellRendererPixbuf(), pixbuf=0)
		self.treeview_series.append_column(column)
		
		column=Gtk.TreeViewColumn("Name", Gtk.CellRendererText(), text=1)
		column.set_resizable(True)
		column.set_sort_column_id(1)
		self.treeview_series.append_column(column)
		
	
		""" 
			liststore_episodes
		"""
		self.treeview_episodes=Gtk.TreeView()
		self.liststore_episodes=Gtk.ListStore(int,str,str,bool,bool,bool,str,str)
		self.treeview_episodes.set_model(self.liststore_episodes)
		self.scrolledwindow_episodes.add(self.treeview_episodes)
		self.treeview_episodes.connect('button-press-event' , self.treeview_episodes_press_event)
		
		
		self.selection_episodes=self.treeview_episodes.get_selection()
		self.selection_episodes.set_mode(Gtk.SelectionMode.MULTIPLE)
		
		
		column=Gtk.TreeViewColumn("N°", Gtk.CellRendererText(), text=0, foreground=7)
		self.treeview_episodes.append_column(column)
		
		self.treeview_name_column=Gtk.TreeViewColumn("Name", Gtk.CellRendererText(), text=1, foreground=7)
		self.treeview_episodes.append_column(self.treeview_name_column)
		self.treeview_name_column.set_resizable(True)
		
		column=Gtk.TreeViewColumn("Founded", Gtk.CellRendererPixbuf(), stock_id=2)
		self.treeview_episodes.append_column(column)
		
		render=Gtk.CellRendererToggle()
		column=Gtk.TreeViewColumn("Play", render, active=3)
		self.treeview_episodes.append_column(column)
		render.connect("toggled", GUI_on_toggle, self.liststore_episodes, 3, self)
		
		render=Gtk.CellRendererToggle()
		column=Gtk.TreeViewColumn("O-Played", render, active=4)
		self.treeview_episodes.append_column(column)
		render.connect("toggled", GUI_on_toggle, self.liststore_episodes, 4, self)
		
		render=Gtk.CellRendererToggle()
		column=Gtk.TreeViewColumn("R-Played", render, active=5)
		self.treeview_episodes.append_column(column)
		render.connect("toggled", GUI_on_toggle, self.liststore_episodes, 5, self)
		
		# this column is only to fill the empty (extra) space
		column=Gtk.TreeViewColumn(" ", Gtk.CellRendererText(), text=6)
		column.set_expand(True)
		self.treeview_episodes.append_column(column)
		
		
		"""
			Current Serie eventbox
		"""
		self.eventbox_selected_serie=Gtk.EventBox()
		self.eventbox_selected_serie.connect('button-press-event' , self.treeview_series_press_event)
		self.box_serie_data.add(self.eventbox_selected_serie)
		self.box_serie_data.reorder_child(self.eventbox_selected_serie, 1)
		
		"""
			vlc player
		"""
		
		self.vlc=DecoratedVLCWidget(self.window_player)
		
		# this 3 lines fixes a segmentation fault problem
		media=instance.media_new('')
		media.parse()
		self.vlc.player.set_media(media)
		
		
		self.window_player.add(self.vlc)
		
		self.thrd=threading.Thread(target=VLC_scan, args=[self])
		self.thrd.start()
		
	
		"""
			configuration
		"""		
		# current media to play
		self.current_media=[None, # serie class
							None, # video class
							None, # random state
							None, # mark
							]
		

		# list of clases
		self.list_series_class=[]
		self.list_episodes_class=[]
		self.selected_row=-1
			
		# font colors
		self.default_font_color=GTK_default_font_color()
		self.hiden_font_color="#FF0000"

		# extra
		self.right_click_menu=None # this is a dirty hack to make the Gtk.Menu work in Debian and Ubuntu.
		self.display_hiden_videos=False
			
		self.window_root.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		self.window_root.connect('delete-event', self.quit_the_program)


		# change the GUI to mini mode if..
		full_mode=CustomParser.get_value(CONFIGURATION_FILE,'vlist-player','fullmode')
		if full_mode=='false' or full_mode=='False':
			GUI_hide_episodes_menu(self)

		# set the default big image
		self.eventbox_selected_serie.add(Gtk.Image.new_from_pixbuf(Pixbuf.new_from_file_at_size(ICON_LOGO_BIG, 160+60,160)))

		"""
			Display the winwdow
		"""
		self.window_root.show_all()
		GUI_hide_episodes_menu(self)
		
		"""
			load the existents lists
		"""
		threading.Thread(target=LOAD_lists, args=[self]).start()


	"""
		***** METHODS ******
	"""

	def quit_the_program(self, widget, data=None):
				
		"""		
			If the vlc player is shown, the root window shouldn't be destroyed.
		"""
		if self.window_player.get_property("visible"):
			self.window_root.hide()
			return True
		
		
		"""
			I removed this part of the code because since I add it it seems that a segmentation fault problem appears some times.
			(different from the one of the bug #666). And since event by using Gtk.main_quit() the app doesn't seems to quit,
			I don't see why  should the function be keeped.
		"""
		#else:					
		#	Gtk.main_quit()

			
	
	def on_checkbutton_random_toggled(self, button, data=None):
		
		# update the series instance
		selected_serie=self.liststore_series[self.selected_row][1]

		for serie in self.list_series_class:
			if serie.get_name()==selected_serie:
				
				checkbutton_state=self.checkbutton_random.get_active()
				
				if self.checkbutton_random.get_active() != serie.get_random():
					serie.set_random(self.checkbutton_random.get_active())
		
		#
		GUI_update_episodes_menu(self,False)
		

	def on_checkbutton_keep_playing_toggled(self, button, data=None):
		# update the series instance
		selected_serie=self.liststore_series[self.selected_row][1]

		for serie in self.list_series_class:
			if serie.get_name()==selected_serie:
				
				checkbutton_state=self.checkbutton_keep_playing.get_active()
				if serie.get_keep_playing != checkbutton_state:
				
					serie.set_keep_playing(checkbutton_state)

	

	def on_button_move_up_clicked(self, button, data=None):
		model, rownumbers=self.selection_episodes.get_selected_rows()	

		if not rownumbers==[]:

			# update the class
			selected_serie=self.liststore_series[self.selected_row][1]

			for serie in self.list_series_class:
				if serie.get_name()==selected_serie:
					serie.move_episodes(rownumbers,'up')
					break

			# update the liststore
			for rownumber in rownumbers:
				rownumber=int(str(rownumber))
				
				if rownumber > 0:
				
					current_iter=self.liststore_episodes.get_iter(rownumber)
					next_iter=self.liststore_episodes.get_iter(rownumber-1)
					
					self.liststore_episodes.move_before(current_iter,next_iter)
					

			# update the numbers of the list store
			i=1
			for row in self.liststore_episodes:
				self.liststore_episodes[i-1][0]=i
				i+=1
						
						
	def on_button_move_down_clicked(self, button, data=None):
		model, rownumbers=self.selection_episodes.get_selected_rows()
		
		if not rownumbers==[]:
	
			# update the class
			selected_serie=self.liststore_series[self.selected_row][1]

			for serie in self.list_series_class:
				if serie.get_name()==selected_serie:
					serie.move_episodes(rownumbers,'down')
					break


			# update the liststore
			for rownumber in rownumbers:
				rownumber=int(str(rownumber))
				
				if rownumber < len(self.liststore_episodes)-1:
				
					current_iter=self.liststore_episodes.get_iter(rownumber)
					next_iter=self.liststore_episodes.get_iter(rownumber+1)
					
					self.liststore_episodes.move_after(current_iter,next_iter)
					

			# update the numbers of the list store
			i=1
			for row in self.liststore_episodes:
				self.liststore_episodes[i-1][0]=i
				i+=1
			
	def on_button_okey_rename_clicked(self, button, data=None):
		
		
		current_name=self.liststore_series[self.selected_row][1]
		new_name=self.entry_rename.get_text()
	
		# if both names are the same, just close the window
		if current_name==new_name:
			self.window_rename.hide()
			return
	
		# abort if the new name already exists
		for serie in self.list_series_class:
			if serie.get_name()==new_name:
				GTK_info(self.window_rename,TEXT_SERIE_NEWNAME_ALREADY_EXISTS.format(new_name),None)
				return
				
		# update the class and the data file
		for serie in self.list_series_class:
			if serie.get_name()==current_name:
				serie.rename(new_name)
		
		#update the liststore
		self.liststore_series[self.selected_row][1]=new_name
		
		# update the label
		self.label_current_serie.set_label(new_name)
		
		#update the screen
		EPISODE_update(self)
		
		self.window_rename.hide()

	def on_checkbutton_hide_extensions_clicked(self, widget, data=None):
		None

	def on_togglebutton_hidden_videos_clicked(self, button, data=None):
		if self.togglebutton_hidden_videos.get_active():
			self.display_hiden_videos=True		
		else:
			self.display_hiden_videos=False
			
		GUI_update_episodes_menu(self, True)
		

	def on_button_close_preferences_clicked(self, button, data=None):
		self.window_preferences.hide()

	def on_button_close_controlls_clicked(self, button, data=None):
		self.window_controlls.hide()
		
	def on_button_close_files_clicked(self, button, data=None):
		self.window_files.hide()
		
	def on_button_cancel_rename_clicked(self, button, data=None):
		self.window_rename.hide()
	
	def on_button_close_window_list_clicked(self,button, data=None):
		self.window_list.hide()
	
	def on_imagemenuitem_preferences_activate(self, button, data=None):
		self.window_preferences.show()

	def on_menuitem_list_from_folder_recursive_activate(self, button,data=None):
		path=GTK_folder_chooser(self.window_root)
		if path:
			for serie in self.list_series_class:
				if serie.get_path()==path:
					GTK_info(self.window_root,TEXT_SERIE_ALREADY_EXISTS,None)
					return
					
					
				if serie.get_name()==serie_name:
					GTK_info(self.window_root,TEXT_SERIE_NAME_ALREADY_EXISTS.format(serie_name),None)
					return
			
			threading.Thread(target=SERIE_load_from_path, args=[self,path,None,True,False,True]).start()


	def on_menuitem_list_from_folder_activate(self, button, data=None):
		path=GTK_folder_chooser(self.window_root)
		if path:
			
			serie_name=os.path.basename(path)
			
			for serie in self.list_series_class:
				if serie.get_path()==path:
					GTK_info(self.window_root,TEXT_SERIE_ALREADY_EXISTS,None)
					return
					
				if serie.get_name()==serie_name:
					GTK_info(self.window_root,TEXT_SERIE_NAME_ALREADY_EXISTS.format(serie_name),None)
					return
					
			
			threading.Thread(target=SERIE_load_from_path, args=[self,path,None,False,False,True]).start()
	
	def on_button_close_find_files_clicked(self, button, data=None):
		self.window_finding_files.hide()


	def on_imagemenuitem_finding_files_activate(self, button, data=None):
		self.window_finding_files.show()

	def on_imagemenuitem_about_activate(self, button, data=None):
		response=self.window_about.run()
		self.window_about.hide()

	def on_imagemenuitem_controls_activate(self, button, data=None):
		self.window_controlls.show()
		
	def on_imagemenuitem_files_activate(self, button, data=None):
		self.window_files.show()	
	
		
	def on_window_root_button_press_event(self, widget, event):
		type=event.type
		#if type==Gdk.BUTTON_PRESS:
		if 'GDK_2BUTTON_PRESS' in str(type):										############## hack #125
			if event.button == 3: # right click
				GUI_hide_episodes_menu(self)



	def treeview_episodes_press_event(self, treeview, event):
		
		(model, rownumbers)=self.selection_episodes.get_selected_rows()
		
		if rownumbers==[]:
			return
		
		# Convert the rownumbers list to a integers list
		rownumbers2=[]
		for rownumber in rownumbers:
			rownumbers2.append(int(str(rownumber)))
		rownumbers=rownumbers2
		
		selection_length=len(rownumbers)
		
		selected_serie=self.liststore_series[self.selected_row][1]
		
		
		"""
			Active or desactive the buttons move up and down
		"""
		if selection_length>=0:
			self.button_move_down.set_sensitive(True)
			self.button_move_up.set_sensitive(True)
		else:
			self.button_move_down.set_sensitive(False)
			self.button_move_up.set_sensitive(False)
		
		
		
		if event.button == 1 and selection_length==1 and 'GDK_2BUTTON_PRESS' in str(event.type):			############## hack #125
			episode_name=self.liststore_episodes[rownumbers[0]][1]
			
			for serie in self.list_series_class:
				if serie.get_name()==selected_serie:
					path=serie.get_path_from_video_name(episode_name)
					
					if path:
						if os.path.exists(path):
							vlc_play_video( self.vlc.player, 
											path,
											self.window_player, 
											False, 
											0)
						else:
							GTK_info(self.window_root,TEXT_CANT_PLAY_MEDIA_MISSING,None)
			
	
		
		elif event.button == 3: # right click
			path, column, __, __ = treeview.get_path_at_pos(int(event.x), int(event.y))
			
			"""
				Create the right click menu
			"""
			self.right_click_menu=None			# dirty hack to clear the menu
			self.right_click_menu=Gtk.Menu()

			"""
				Open the containing folder (only if the user selected one video)
			"""
			if selection_length==1:	
				
				selected_video=self.liststore_episodes[rownumbers[0]][1]
				
				
				menuitem=Gtk.ImageMenuItem("Folder")
				self.right_click_menu.append(menuitem)
				menuitem.connect("activate", EPISODE_open_dir, self, selected_video)
				img = Gtk.Image(stock=Gtk.STOCK_OPEN)
				menuitem.set_image(img)


			elif selection_length>1:
				
				list=["Play","O-Played","R-Played"]
				i=3
				for label in list:
				
					# mark to check
					menuitem=Gtk.ImageMenuItem(label)
					self.right_click_menu.append(menuitem)
					menuitem.connect("activate", GUI_checkboxes, i, True, self)
					img = Gtk.Image(stock=Gtk.STOCK_APPLY)										
					menuitem.set_image(img)
					
					# mark to uncheck
					menuitem=Gtk.ImageMenuItem(label)
					self.right_click_menu.append(menuitem)
					menuitem.connect("activate", GUI_checkboxes, i, False, self)		
					img = Gtk.Image(stock=Gtk.STOCK_MISSING_IMAGE)								
					menuitem.set_image(img)
					i+=1
					

			
			"""
				Menu "Fin videos"
			"""	
			list_of_names=[]
			for rownumber in rownumbers:
				list_of_names.append(self.liststore_episodes[rownumber][1])

			if self.list_series_class[self.selected_row].missing_videos(list_of_names):

				menuitem=Gtk.ImageMenuItem("Find")
				menuitem.connect("activate", SERIE_find_videos, self, list_of_names)
				self.right_click_menu.append(menuitem)
				img = Gtk.Image(stock=Gtk.STOCK_DIALOG_WARNING)
				menuitem.set_image(img)


			
			# ignore videos
			menuitem=Gtk.ImageMenuItem("Ignore")
			self.right_click_menu.append(menuitem)
			menuitem.connect("activate", SERIE_ignore_episode,self)
			img = Gtk.Image(stock=Gtk.STOCK_FIND_AND_REPLACE)
			menuitem.set_image(img)
			
			# don't ignore videos
			menuitem=Gtk.ImageMenuItem("Don't Ignore")
			self.right_click_menu.append(menuitem)
			menuitem.connect("activate", SERIE_dont_ignore_episode,self)
			img = Gtk.Image(stock=Gtk.STOCK_FIND)
			menuitem.set_image(img)
			
			
			self.right_click_menu.popup(None, None, lambda menu, data: (event.get_root_coords()[0],
														  event.get_root_coords()[1], True),
															None, event.button, event.time)
					   
			
			self.right_click_menu.show_all()
			
			return True
			

	def treeview_series_selection_changed(self, treeselection):
		
		(model, rownumbers)=treeselection.get_selected_rows()
		
		if not rownumbers==[]:
			self.selected_row=int(str(rownumbers[0]))
			GUI_update_episodes_menu(self,True)
		
		
	def treeview_series_press_event(self, treeview, event):
		
		# check if some row is selected
		if self.selected_row < 0:
			return
		
		# check if the liststore is empty
		for row in self.liststore_episodes:
			break
		else:
			GTK_info(self.window_root,TEXT_CANT_PLAY_SERIE_MISSING,None)
		
		
		self.button_move_down.set_sensitive(False)
		self.button_move_up.set_sensitive(False)
		
		current_serie_name=self.liststore_series[self.selected_row][1]

		# find if the serie is missing
		missing_folder=False
		for serie in self.list_series_class:
			if serie.get_name()==current_serie_name:
				if not os.path.exists(serie.get_path()):
					missing_folder=True
				break
				

		type=event.type
		
		#if type==Gdk.BUTTON_PRESS:
		if 'GDK_BUTTON_PRESS' in str(type):										############## hack #125
			
			if self.selected_row >=0:
				if event.button == 3:
					""" 
						Right click menu
					"""
					self.right_click_menu=None			# dirty hack to clear the menu
					self.right_click_menu=Gtk.Menu()
				
					if not missing_folder:
						menuitem=Gtk.ImageMenuItem("Open Folder")
						self.right_click_menu.append(menuitem)
						menuitem.connect("activate", SERIE_open, self)
						img = Gtk.Image(stock=Gtk.STOCK_OPEN)
						menuitem.set_image(img)
						
						menuitem=Gtk.ImageMenuItem("Rename")
						self.right_click_menu.append(menuitem)
						menuitem.connect("activate", SERIE_rename, self)
						img = Gtk.Image(stock=Gtk.STOCK_BOLD)
						menuitem.set_image(img)
						
						menuitem=Gtk.ImageMenuItem("Reset")
						self.right_click_menu.append(menuitem)
						menuitem.connect("activate", SERIE_reset, self)
						img = Gtk.Image(stock=Gtk.STOCK_REFRESH)
						menuitem.set_image(img)
					
						menuitem=Gtk.ImageMenuItem("Add Picture")
						self.right_click_menu.append(menuitem)
						menuitem.connect("activate", SERIE_add_picture, self)
						img = Gtk.Image(stock=Gtk.STOCK_SELECT_COLOR)
						menuitem.set_image(img)
					else:
						menuitem=Gtk.ImageMenuItem("Find")
						self.right_click_menu.append(menuitem)
						menuitem.connect("activate", SERIE_find, self)
						img = Gtk.Image(stock=Gtk.STOCK_DIALOG_WARNING)
						menuitem.set_image(img)
						
				
					menuitem=Gtk.ImageMenuItem("Delete")
					self.right_click_menu.append(menuitem)
					menuitem.connect("activate", SERIE_delete, self)
					img = Gtk.Image(stock=Gtk.STOCK_CANCEL)
					menuitem.set_image(img)
					
					
					self.right_click_menu.popup(None, None, lambda menu, data: (event.get_root_coords()[0],
																  event.get_root_coords()[1], True),
																	None, event.button, event.time)
							   
					
					self.right_click_menu.show_all()
					
					return True 
					
		
				
		#elif type==Gdk._2BUTTON_PRESS:											
		elif 'GDK_2BUTTON_PRESS' in str(type):										############## hack #125
			if event.button == 1: # left click
				"""
					Play a video of the serie
				"""
				GUI_update_episodes_menu(self,True)
				CustomParser.write_value(CONFIGURATION_FILE,'vlist-player','current_series',current_serie_name)
				
				state=self.vlc.player.get_state()
				if (not 'Playing' in str(state) and not 'Pause' in str(state)) \
					or self.current_media[0].get_name()!=current_serie_name:
					
					EPISODE_update(self)
					if self.current_media[1]:
						if os.path.exists(self.current_media[1].get_path()):
							vlc_play_video( self.vlc.player,
											self.current_media[1].get_path(),
											self.window_player, 
											False, 
											self.current_media[1].get_position())
						else:
							GTK_info(self.window_root,TEXT_CANT_PLAY_MEDIA_MISSING,None)
					else:
						GTK_info(self.window_root,TEXT_END_OF_SERIE,None)


def LOAD_lists(self):
	"""
		Load the saved lists
	"""	
	if os.path.exists(FOLDER_LIST_PATH):
		data_files=[ f for f in os.listdir(FOLDER_LIST_PATH) if os.path.isfile(os.path.join(FOLDER_LIST_PATH,f)) ]
		data_files.sort()
		for data_file in data_files:
			if ".csv" in data_file:
				
				data_path=FOLDER_LIST_PATH+"/"+data_file
				
				with open(data_path, 'r') as f:
					try:
						try: # support for versions <= 0.0~0
							serie_info=f.readline().strip()
							serie_info=serie_info.split("|")
							
							path=serie_info[0]
							recursive=serie_info[1]
							
							try: # support for   0.0~0 > versions < 0.1~7
								random=serie_info[2]
								keep_playing=serie_info[3]
								
							except Exception,e:
								print str(e)
								keep_playing=True
								random=False
							
						except Exception,e:
							print str(e) 
							path=readline().strip()
							recursive=False
							keep_playing=True
							random=False
							
						SERIE_load_from_path(self, path, data_path, recursive, random, keep_playing)

					except Exception,e:
						print str(e)

		"""
			Load the last serie that has been played
		"""
		current_serie=CustomParser.get_value(CONFIGURATION_FILE,'vlist-player','current_series')
		i=0
		if current_serie:
			for serie in self.list_series_class:
				if serie.get_name()==current_serie:
					Gdk.threads_enter()
					self.treeview_series.set_cursor(i)
					Gdk.threads_leave()
					break
					
				i+=1

				
if __name__ == "__main__":

	GObject.threads_init()
	Gdk.threads_init()


	main=GUI()
	Gtk.main()
